/*
** Highscore loading and saving routines for GamePark32
** Added by Andreas Gustafsson 030607
** sdw@lysator.liu.se
*/

#include <stdio.h>
#include <stdlib.h>
#ifdef GP2X
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpstdio.h"
#else
#endif
#include "game.h"

extern hscore_t game_hscores[8];
keys_t game_savedkeys;

void ReadHiScores()
{
#ifdef GP2X
	F_HANDLE fi;
	unsigned long bytesRead=0;

	GpFatInit();		
	if(GpFileOpen("gp:\\GPMM\\XRICK.HIS",OPEN_R,&fi)==SM_OK)
	{
		if(GpFileRead(fi,game_hscores,sizeof(hscore_t)*8,&bytesRead)==SM_OK)
		{
			if(bytesRead!=sizeof(hscore_t)*8)
			{
				/* Error, reset scores?*/
			}
		}
		GpFileClose(fi);
	}
#else
	FILE* f = fopen("C:\\shared\\xrick\\xrick.his","rb");
	if(f != NULL)
		{
		fread((void*) &game_hscores, sizeof(hscore_t)*8,1, f);
		if( fread((void*) &game_savedkeys, sizeof(keys_t),1, f) > 0)
			{		
			syskbd_up = game_savedkeys.syskbd_up;
			syskbd_down = game_savedkeys.syskbd_down;
			syskbd_left = game_savedkeys.syskbd_left;
			syskbd_right = game_savedkeys.syskbd_right;
			syskbd_pause = game_savedkeys.syskbd_pause;
			syskbd_end = game_savedkeys.syskbd_end;
			syskbd_xtra = game_savedkeys.syskbd_xtra;
			syskbd_fire = game_savedkeys.syskbd_fire;			
			syskbd_upright = game_savedkeys.syskbd_upright;
			syskbd_downleft = game_savedkeys.syskbd_downleft;
			syskbd_upleft = game_savedkeys.syskbd_upleft;
			syskbd_downright= game_savedkeys.syskbd_downright;
			}
		fclose(f);
		}
#endif
}

void WriteHiScores()
{
#ifdef GP2X
	F_HANDLE fi;

	if(GpFileCreate("gp:\\GPMM\\XRICK.HIS",ALWAYS_CREATE,&fi)!=SM_OK) return;
	if(GpFileOpen("gp:\\GPMM\\XRICK.HIS",OPEN_W,&fi)==SM_OK)
		{
		GpFileWrite(fi,game_hscores,sizeof(hscore_t)*8);
		GpFileClose(fi);
		}
#else
	FILE* f = fopen("C:\\shared\\xrick\\xrick.his","wb");
	if(f != NULL)
		{
		game_savedkeys.syskbd_up = syskbd_up;
		game_savedkeys.syskbd_down = syskbd_down;
		game_savedkeys.syskbd_left = syskbd_left;
		game_savedkeys.syskbd_right = syskbd_right;
		game_savedkeys.syskbd_pause = syskbd_pause;
		game_savedkeys.syskbd_end = syskbd_end;
		game_savedkeys.syskbd_xtra = syskbd_xtra;
		game_savedkeys.syskbd_fire = syskbd_fire;			
		game_savedkeys.syskbd_upright = syskbd_upright;
		game_savedkeys.syskbd_downleft = syskbd_downleft;
		game_savedkeys.syskbd_upleft = syskbd_upleft;
		game_savedkeys.syskbd_downright = syskbd_downright;
		fwrite(&game_hscores, sizeof(hscore_t)*8,1, f);
		fwrite(&game_savedkeys, sizeof(keys_t),1, f);
		fclose(f);
		}
#endif
}
